def f1_1():
    """
В первой корзине имеется 11 шаров, при этом количество белых шаров равно либо 3, либо 10.
Оба варианта равновероятны. Во второй корзине имеется 25 шаров, а количество белых шаров равно 2, 23 или 25.
Эти три варианта также равновероятны. Из обеих корзин все шары перекладываются в третью корзину.
Какова вероятность P(A), что случайно вынутый из третьей корзины шар окажется белым (событие A)?
Найдите условную вероятность P(H|A), того, что случайно вынутый из третьей корзины шар
первоначально находился в первой корзине (событие H), при условии, что он белый (событие A)?


# Вероятности для корзины 1
P_B1 = 0.5  # Вероятность, что в корзине 1 3 белых шара
P_B2 = 0.5  # Вероятность, что в корзине 1 10 белых шаров

# Вероятности для корзины 2
P_C1 = 1/3  # Вероятность, что в корзине 2 2 белых шара
P_C2 = 1/3  # Вероятность, что в корзине 2 23 белых шара
P_C3 = 1/3  # Вероятность, что в корзине 2 25 белых шара

# Общее количество шаров в каждой корзине
total_balls_1 = 11
total_balls_2 = 25

# Число белых шаров в каждом случае
white_balls_B1 = 3
white_balls_B2 = 10

white_balls_C1 = 2
white_balls_C2 = 23
white_balls_C3 = 25

# Рассчитываем вероятности события A для каждого сочетания
P_A_given_B1_C1 = (white_balls_B1 + white_balls_C1) / (total_balls_1 + total_balls_2)
P_A_given_B1_C2 = (white_balls_B1 + white_balls_C2) / (total_balls_1 + total_balls_2)
P_A_given_B1_C3 = (white_balls_B1 + white_balls_C3) / (total_balls_1 + total_balls_2)
P_A_given_B2_C1 = (white_balls_B2 + white_balls_C1) / (total_balls_1 + total_balls_2)
P_A_given_B2_C2 = (white_balls_B2 + white_balls_C2) / (total_balls_1 + total_balls_2)
P_A_given_B2_C3 = (white_balls_B2 + white_balls_C3) / (total_balls_1 + total_balls_2)

# Общая вероятность события A
P_A = (
    P_B1 * P_C1 * P_A_given_B1_C1 +
    P_B1 * P_C2 * P_A_given_B1_C2 +
    P_B1 * P_C3 * P_A_given_B1_C3 +
    P_B2 * P_C1 * P_A_given_B2_C1 +
    P_B2 * P_C2 * P_A_given_B2_C2 +
    P_B2 * P_C3 * P_A_given_B2_C3
)

# Вероятность того, что белый шар из первой корзины
P_H = total_balls_1 / (total_balls_1 + total_balls_2)

# Вероятности P(A|H)
P_A_given_H = (P_B1 * white_balls_B1 / total_balls_1 + P_B2 * white_balls_B2 / total_balls_1)

# Условная вероятность P(H|A)
P_H_given_A = (P_A_given_H * P_H) / P_A

# Выводим результаты
print(f"Вероятность P(A), что случайно вынутый из третьей корзины шар окажется белым: {P_A:.4f}")
print(f"Условная вероятность P(H|A), что белый шар из первой корзины: {P_H_given_A:.4f}")
----------------------------------------------

Имеется две корзины с белыми и черными шарами. В первой корзине всего 6 шаров,
при этом количество белых шаров распределено по биномиальному закону с параметрами n = 3 и p = 0,8.
Во второй корзине имеется всего 11 шаров, при этом количество белых шаров распределено
по биномиальному закону с параметрами n = 4 и p = 0,7.
Из обеих корзин все шары перекладываются в третью корзину. 1) Какова вероятность P(A), что случайно вынутый из третьей
корзины шар окажется белым (событие A)?
2) Найдите условную вероятность P(H|A), того, что случайно вынутый из
третьей корзины шар первоначально находился в первой корзине (событие H), при условии, что он белый (событие A)?


from scipy.stats import *
u_1 = binom(3, 0.8)
u_2 = binom(4, 0.7)
A = 0
H = 0
for n1 in range(u_1.args[0]+1):
    for n2 in range(u_2.args[0]+1):
        A += u_1.pmf(n1)*u_2.pmf(n2)*((n1+n2)/17)
        H += u_1.pmf(n1)*u_2.pmf(n2)*(n1/17)
print(A)
print(H/A)

--------------------------------

1. Имеется две корзины с белыми и черными шарами.
В первой корзине количество белых – 11, количество черных – 12.
Во второй корзине количество белых – 17, количество черных – 18.
Из первой корзины случайно, без возвращения, излекаются 5 шаров, а из второй – 6 шаров.
Отобранные из обеих корзин шары перекладываются в третью корзину.
1) Какова вероятность $P(A)$, что случайно вынутый из третьей корзины шар окажется белым (событие $A$)?
2) Найдите условную вероятность $P(H|A)$, того, что случайно вынутый из третьей корзины шар
первоначально находился в первой корзине (событие $H$), при условии, что он белый (событие $A$)?<br/>


wt1, bl1 = 11, 12

wt2, bl2 = 17, 18


take1 = 5
take2 = 6

balls1 = wt1 + bl1
balls2 = wt2 + bl2

p_h1 = take1 / (take2 + take1)
p_h2 = take2 / (take2 + take1)

p_ah1 = wt1 / balls1
p_ah2 = wt2 / balls2


p_a = p_h1 * p_ah1 + p_h2 * p_ah2
print(f"{p_a}".replace(".", ","))

p_ha = p_h1 * p_ah1 / p_a
print(f"{p_ha}".replace(".", ","))
--------------------------------------------

Имеется 37 монет, из которых 6 бракованные: вследствие заводского брака на этих монетах с обеих сторон отчеканен герб. Наугад выбранную монету, не разглядывая, бросают несколько раз.

Какова вероятность, что при 4 бросках она ляжет гербом вверх?
При 4 бросках монета легла гербом вверх. Какова вероятность того, что была выбрана монета с двумя гербами?



# Определим вероятности и количество монет
total_coins = 37
defective_coins = 6
normal_coins = total_coins - defective_coins

# Вероятности выпадения герба при броске
P_heads_normal = 0.5
P_heads_defective = 1.0

# Вероятности выпадения герба 4 раза подряд
P_4_heads_normal = P_heads_normal ** 4
P_4_heads_defective = P_heads_defective ** 4

# Вероятности выбора монет
P_normal = normal_coins / total_coins
P_defective = defective_coins / total_coins

# Общая вероятность выпадения 4 гербов подряд
P_4_heads_total = P_4_heads_normal * P_normal + P_4_heads_defective * P_defective

# Условная вероятность, что выбрана бракованная монета, если выпало 4 герба подряд
P_defective_given_4_heads = (P_4_heads_defective * P_defective) / P_4_heads_total

# Вывод результатов
print(f"Вероятность того, что при 4 бросках монета ляжет гербом вверх: {P_4_heads_total:.4f}")
print(f"Вероятность того, что была выбрана монета с двумя гербами: {P_defective_given_4_heads:.4f}")


    """

print(f1_1.__doc__)